/*
Model Catalog REST API

REST API for Model Registry to create and manage ML model metadata

API version: v1alpha1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// checks if the CatalogModelArtifactList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CatalogModelArtifactList{}

// CatalogModelArtifactList List of CatalogModel entities.
type CatalogModelArtifactList struct {
	// Token to use to retrieve next page of results.
	NextPageToken string `json:"nextPageToken"`
	// Maximum number of resources to return in the result.
	PageSize int32 `json:"pageSize"`
	// Number of items in result list.
	Size int32 `json:"size"`
	// Array of `CatalogModelArtifact` entities.
	Items []CatalogModelArtifact `json:"items"`
}

// NewCatalogModelArtifactList instantiates a new CatalogModelArtifactList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCatalogModelArtifactList(nextPageToken string, pageSize int32, size int32, items []CatalogModelArtifact) *CatalogModelArtifactList {
	this := CatalogModelArtifactList{}
	this.NextPageToken = nextPageToken
	this.PageSize = pageSize
	this.Size = size
	this.Items = items
	return &this
}

// NewCatalogModelArtifactListWithDefaults instantiates a new CatalogModelArtifactList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCatalogModelArtifactListWithDefaults() *CatalogModelArtifactList {
	this := CatalogModelArtifactList{}
	return &this
}

// GetNextPageToken returns the NextPageToken field value
func (o *CatalogModelArtifactList) GetNextPageToken() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.NextPageToken
}

// GetNextPageTokenOk returns a tuple with the NextPageToken field value
// and a boolean to check if the value has been set.
func (o *CatalogModelArtifactList) GetNextPageTokenOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.NextPageToken, true
}

// SetNextPageToken sets field value
func (o *CatalogModelArtifactList) SetNextPageToken(v string) {
	o.NextPageToken = v
}

// GetPageSize returns the PageSize field value
func (o *CatalogModelArtifactList) GetPageSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.PageSize
}

// GetPageSizeOk returns a tuple with the PageSize field value
// and a boolean to check if the value has been set.
func (o *CatalogModelArtifactList) GetPageSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PageSize, true
}

// SetPageSize sets field value
func (o *CatalogModelArtifactList) SetPageSize(v int32) {
	o.PageSize = v
}

// GetSize returns the Size field value
func (o *CatalogModelArtifactList) GetSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Size
}

// GetSizeOk returns a tuple with the Size field value
// and a boolean to check if the value has been set.
func (o *CatalogModelArtifactList) GetSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Size, true
}

// SetSize sets field value
func (o *CatalogModelArtifactList) SetSize(v int32) {
	o.Size = v
}

// GetItems returns the Items field value
func (o *CatalogModelArtifactList) GetItems() []CatalogModelArtifact {
	if o == nil {
		var ret []CatalogModelArtifact
		return ret
	}

	return o.Items
}

// GetItemsOk returns a tuple with the Items field value
// and a boolean to check if the value has been set.
func (o *CatalogModelArtifactList) GetItemsOk() ([]CatalogModelArtifact, bool) {
	if o == nil {
		return nil, false
	}
	return o.Items, true
}

// SetItems sets field value
func (o *CatalogModelArtifactList) SetItems(v []CatalogModelArtifact) {
	o.Items = v
}

func (o CatalogModelArtifactList) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CatalogModelArtifactList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["nextPageToken"] = o.NextPageToken
	toSerialize["pageSize"] = o.PageSize
	toSerialize["size"] = o.Size
	toSerialize["items"] = o.Items
	return toSerialize, nil
}

type NullableCatalogModelArtifactList struct {
	value *CatalogModelArtifactList
	isSet bool
}

func (v NullableCatalogModelArtifactList) Get() *CatalogModelArtifactList {
	return v.value
}

func (v *NullableCatalogModelArtifactList) Set(val *CatalogModelArtifactList) {
	v.value = val
	v.isSet = true
}

func (v NullableCatalogModelArtifactList) IsSet() bool {
	return v.isSet
}

func (v *NullableCatalogModelArtifactList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCatalogModelArtifactList(val *CatalogModelArtifactList) *NullableCatalogModelArtifactList {
	return &NullableCatalogModelArtifactList{value: val, isSet: true}
}

func (v NullableCatalogModelArtifactList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCatalogModelArtifactList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
