/*
Model Catalog REST API

REST API for Model Registry to create and manage ML model metadata

API version: v1alpha1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// checks if the CatalogModelList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CatalogModelList{}

// CatalogModelList List of CatalogModel entities.
type CatalogModelList struct {
	// Token to use to retrieve next page of results.
	NextPageToken string `json:"nextPageToken"`
	// Maximum number of resources to return in the result.
	PageSize int32 `json:"pageSize"`
	// Number of items in result list.
	Size int32 `json:"size"`
	// Array of `CatalogModel` entities.
	Items []CatalogModel `json:"items"`
}

// NewCatalogModelList instantiates a new CatalogModelList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCatalogModelList(nextPageToken string, pageSize int32, size int32, items []CatalogModel) *CatalogModelList {
	this := CatalogModelList{}
	this.NextPageToken = nextPageToken
	this.PageSize = pageSize
	this.Size = size
	this.Items = items
	return &this
}

// NewCatalogModelListWithDefaults instantiates a new CatalogModelList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCatalogModelListWithDefaults() *CatalogModelList {
	this := CatalogModelList{}
	return &this
}

// GetNextPageToken returns the NextPageToken field value
func (o *CatalogModelList) GetNextPageToken() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.NextPageToken
}

// GetNextPageTokenOk returns a tuple with the NextPageToken field value
// and a boolean to check if the value has been set.
func (o *CatalogModelList) GetNextPageTokenOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.NextPageToken, true
}

// SetNextPageToken sets field value
func (o *CatalogModelList) SetNextPageToken(v string) {
	o.NextPageToken = v
}

// GetPageSize returns the PageSize field value
func (o *CatalogModelList) GetPageSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.PageSize
}

// GetPageSizeOk returns a tuple with the PageSize field value
// and a boolean to check if the value has been set.
func (o *CatalogModelList) GetPageSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PageSize, true
}

// SetPageSize sets field value
func (o *CatalogModelList) SetPageSize(v int32) {
	o.PageSize = v
}

// GetSize returns the Size field value
func (o *CatalogModelList) GetSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Size
}

// GetSizeOk returns a tuple with the Size field value
// and a boolean to check if the value has been set.
func (o *CatalogModelList) GetSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Size, true
}

// SetSize sets field value
func (o *CatalogModelList) SetSize(v int32) {
	o.Size = v
}

// GetItems returns the Items field value
func (o *CatalogModelList) GetItems() []CatalogModel {
	if o == nil {
		var ret []CatalogModel
		return ret
	}

	return o.Items
}

// GetItemsOk returns a tuple with the Items field value
// and a boolean to check if the value has been set.
func (o *CatalogModelList) GetItemsOk() ([]CatalogModel, bool) {
	if o == nil {
		return nil, false
	}
	return o.Items, true
}

// SetItems sets field value
func (o *CatalogModelList) SetItems(v []CatalogModel) {
	o.Items = v
}

func (o CatalogModelList) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CatalogModelList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["nextPageToken"] = o.NextPageToken
	toSerialize["pageSize"] = o.PageSize
	toSerialize["size"] = o.Size
	toSerialize["items"] = o.Items
	return toSerialize, nil
}

type NullableCatalogModelList struct {
	value *CatalogModelList
	isSet bool
}

func (v NullableCatalogModelList) Get() *CatalogModelList {
	return v.value
}

func (v *NullableCatalogModelList) Set(val *CatalogModelList) {
	v.value = val
	v.isSet = true
}

func (v NullableCatalogModelList) IsSet() bool {
	return v.isSet
}

func (v *NullableCatalogModelList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCatalogModelList(val *CatalogModelList) *NullableCatalogModelList {
	return &NullableCatalogModelList{value: val, isSet: true}
}

func (v NullableCatalogModelList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCatalogModelList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
