/*
Model Registry REST API

REST API for Model Registry to create and manage ML model metadata

API version: v1alpha3
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// checks if the ArtifactList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ArtifactList{}

// ArtifactList A list of Artifact entities.
type ArtifactList struct {
	// Token to use to retrieve next page of results.
	NextPageToken string `json:"nextPageToken"`
	// Maximum number of resources to return in the result.
	PageSize int32 `json:"pageSize"`
	// Number of items in result list.
	Size int32 `json:"size"`
	// Array of `Artifact` entities.
	Items []Artifact `json:"items"`
}

// NewArtifactList instantiates a new ArtifactList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewArtifactList(nextPageToken string, pageSize int32, size int32, items []Artifact) *ArtifactList {
	this := ArtifactList{}
	this.NextPageToken = nextPageToken
	this.PageSize = pageSize
	this.Size = size
	this.Items = items
	return &this
}

// NewArtifactListWithDefaults instantiates a new ArtifactList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewArtifactListWithDefaults() *ArtifactList {
	this := ArtifactList{}
	return &this
}

// GetNextPageToken returns the NextPageToken field value
func (o *ArtifactList) GetNextPageToken() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.NextPageToken
}

// GetNextPageTokenOk returns a tuple with the NextPageToken field value
// and a boolean to check if the value has been set.
func (o *ArtifactList) GetNextPageTokenOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.NextPageToken, true
}

// SetNextPageToken sets field value
func (o *ArtifactList) SetNextPageToken(v string) {
	o.NextPageToken = v
}

// GetPageSize returns the PageSize field value
func (o *ArtifactList) GetPageSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.PageSize
}

// GetPageSizeOk returns a tuple with the PageSize field value
// and a boolean to check if the value has been set.
func (o *ArtifactList) GetPageSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PageSize, true
}

// SetPageSize sets field value
func (o *ArtifactList) SetPageSize(v int32) {
	o.PageSize = v
}

// GetSize returns the Size field value
func (o *ArtifactList) GetSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Size
}

// GetSizeOk returns a tuple with the Size field value
// and a boolean to check if the value has been set.
func (o *ArtifactList) GetSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Size, true
}

// SetSize sets field value
func (o *ArtifactList) SetSize(v int32) {
	o.Size = v
}

// GetItems returns the Items field value
func (o *ArtifactList) GetItems() []Artifact {
	if o == nil {
		var ret []Artifact
		return ret
	}

	return o.Items
}

// GetItemsOk returns a tuple with the Items field value
// and a boolean to check if the value has been set.
func (o *ArtifactList) GetItemsOk() ([]Artifact, bool) {
	if o == nil {
		return nil, false
	}
	return o.Items, true
}

// SetItems sets field value
func (o *ArtifactList) SetItems(v []Artifact) {
	o.Items = v
}

func (o ArtifactList) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ArtifactList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["nextPageToken"] = o.NextPageToken
	toSerialize["pageSize"] = o.PageSize
	toSerialize["size"] = o.Size
	toSerialize["items"] = o.Items
	return toSerialize, nil
}

type NullableArtifactList struct {
	value *ArtifactList
	isSet bool
}

func (v NullableArtifactList) Get() *ArtifactList {
	return v.value
}

func (v *NullableArtifactList) Set(val *ArtifactList) {
	v.value = val
	v.isSet = true
}

func (v NullableArtifactList) IsSet() bool {
	return v.isSet
}

func (v *NullableArtifactList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableArtifactList(val *ArtifactList) *NullableArtifactList {
	return &NullableArtifactList{value: val, isSet: true}
}

func (v NullableArtifactList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableArtifactList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
